## visad
Class RemoteDataImpl

    java.lang.Object
      java.rmi.server.RemoteObject
          java.rmi.server.RemoteServer
              java.rmi.server.UnicastRemoteObject
                  visad.RemoteThingImpl
                      visad.RemoteDataImpl

All Implemented Interfaces:
  Data, Remote, RemoteData, RemoteThing, Serializable, Thing

Direct Known Subclasses:
  RemoteClusterDataImpl, RemoteFunctionImpl

public class RemoteDataImpl
extends RemoteThingImpl
implements RemoteData

RemoteDataImpl is the VisAD remote adapter for DataImpl.

Adapts methods from DataImpl, but not: equals, toString, hashCode or clone.

See Also:
  Serialized Form

Field Summary
`(package private) DataImpl` `AdaptedData` 'this' is the Remote adaptor for AdaptedData (which is local); AdaptedData is transient because UnicastRemoteObject is Serializable, but a copy of 'this' on another JVM will not be local to AdaptedData and cannot adapt it; the methods of RemoteDataImpl test for null AdaptedData

Fields inherited from class visad.RemoteThingImpl
`AdaptedThing`

Fields inherited from class java.rmi.server.RemoteObject
`ref`

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Constructor Summary
`RemoteDataImpl(DataImpl data)` construct a RemoteDataImpl adapting local data

Method Summary
`Data` `abs()` call unary() to take the absolute value of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `abs(int sampling_mode, int error_mode)` call unary() to take the absolute value of this
`Data` `acos()` call unary() to take the arccos of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `acos(int sampling_mode, int error_mode)` call unary() to take the arccos of this producing radian Units
`Data` `acosDegrees()` call unary() to take the arccos of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `acosDegrees(int sampling_mode, int error_mode)` call unary() to take the arccos of this producing degree Units
`Data` `add(Data data)` call binary() to add data to this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `add(Data data, int sampling_mode, int error_mode)` call binary() to add data to this
`Data` `adjustSamplingError(Data error, int error_mode)` return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode
`Data` `asin()` call unary() to take the arcsin of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `asin(int sampling_mode, int error_mode)` call unary() to take the arcsin of this producing radian Units
`Data` `asinDegrees()` call unary() to take the arcsin of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `asinDegrees(int sampling_mode, int error_mode)` call unary() to take the arcsin of this producing degree Units
`Data` `atan()` call unary() to take the arctan of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atan(int sampling_mode, int error_mode)` call unary() to take the arctan of this producing radian Units
`Data` `atan2(Data data)` call binary() to take the atan of this by data producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atan2(Data data, int sampling_mode, int error_mode)` call binary() to take the atan of this by data producing radian Units
`Data` `atan2Degrees(Data data)` call binary() to take the atan of this by data producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atan2Degrees(Data data, int sampling_mode, int error_mode)` call binary() to take the atan of this by data producing degree Units
`Data` `atanDegrees()` call unary() to take the arctan of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `atanDegrees(int sampling_mode, int error_mode)` call unary() to take the arctan of this producing degree Units
`Data` `binary(Data data, int op, int sampling_mode, int error_mode)` Pointwise binary operation between this (AdaptedData) and data.
`Data` `binary(Data data, int op, MathType new_type, int sampling_mode, int error_mode)` Pointwise binary operation between this (AdaptedData) and data.
`Data` `ceil()` call unary() to take the ceiling of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `ceil(int sampling_mode, int error_mode)` call unary() to take the ceiling of this
`Data` `changeMathType(MathType new_type)` call unary() to clone this except with a new MathType
`double[][]` `computeRanges(RealType[] reals)` compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D
`DataShadow` `computeRanges(ShadowType type, DataShadow shadow)` Recursive version of computeRanges(), called down through Data object tree.
`DataShadow` `computeRanges(ShadowType type, int n)` Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector.
`Data` `cos()` call unary() to take the cos of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `cos(int sampling_mode, int error_mode)` call unary() to take the cos of this assuming radian Units unless this actual Units are degrees
`Data` `cosDegrees()` call unary() to take the cos of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `cosDegrees(int sampling_mode, int error_mode)` call unary() to take the cos of this assuming degree Units unless this actual Units are radians
`Object` `dataClone()` A VisAD adaptation of clone that works for local or remote Data.
`Data` `divide(Data data)` call binary() to divide this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `divide(Data data, int sampling_mode, int error_mode)` call binary() to divide this by data
`Data` `exp()` call unary() to take the exponent of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `exp(int sampling_mode, int error_mode)` call unary() to take the exponent of this
`Data` `floor()` call unary() to take the floor of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `floor(int sampling_mode, int error_mode)` call unary() to take the floor of this
`MathType` `getType()`
`boolean` `isMissing()`
`DataImpl` `local()`
`Data` `log()` call unary() to take the log of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `log(int sampling_mode, int error_mode)` call unary() to take the log of this
`String` `longString()`
`String` `longString(String pre)`
`Data` `max(Data data)` call binary() to take the max of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `max(Data data, int sampling_mode, int error_mode)` call binary() to take the max of this and data
`Data` `min(Data data)` call binary() to take the min of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `min(Data data, int sampling_mode, int error_mode)` call binary() to take the min of this and data
`Data` `multiply(Data data)` call binary() to multiply this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `multiply(Data data, int sampling_mode, int error_mode)` call binary() to multiply this by data
`Data` `negate()` call unary() to negate this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `negate(int sampling_mode, int error_mode)` call unary() to negate this
`Data` `pow(Data data)` call binary() to raise this to data power, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `pow(Data data, int sampling_mode, int error_mode)` call binary() to raise this to data power
`Data` `remainder(Data data)` call binary() to take the remainder of this divided by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `remainder(Data data, int sampling_mode, int error_mode)` call binary() to take the remainder of this divided by data
`Data` `rint()` call unary() to take the rint (essentially round) of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `rint(int sampling_mode, int error_mode)` call unary() to take the rint (essentially round) of this
`Data` `round()` call unary() to take the round of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `round(int sampling_mode, int error_mode)` call unary() to take the round of this
`Data` `sin()` call unary() to take the sin of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `sin(int sampling_mode, int error_mode)` call unary() to take the sin of this assuming radian Units unless this actual Units are degrees
`Data` `sinDegrees()` call unary() to take the sin of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `sinDegrees(int sampling_mode, int error_mode)` call unary() to take the sin of this assuming degree Units unless this actual Units are radians
`Data` `sqrt()` call unary() to take the square root of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `sqrt(int sampling_mode, int error_mode)` call unary() to take the square root of this
`Data` `subtract(Data data)` call binary() to subtract data from this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `subtract(Data data, int sampling_mode, int error_mode)` call binary() to subtract data from this
`Data` `tan()` call unary() to take the tan of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `tan(int sampling_mode, int error_mode)` call unary() to take the tan of this assuming radian Units unless this actual Units are degrees
`Data` `tanDegrees()` call unary() to take the tan of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)
`Data` `tanDegrees(int sampling_mode, int error_mode)` call unary() to take the tan of this assuming degree Units unless this actual Units are radians
`Data` `unary(int op, int sampling_mode, int error_mode)` Pointwise unary operation applied to this (AdaptedData).
`Data` `unary(int op, MathType new_type, int sampling_mode, int error_mode)` Pointwise unary operation applied to this (AdaptedData).

Methods inherited from class visad.RemoteThingImpl
`addReference, getTick, incTick, removeReference`

Methods inherited from class java.rmi.server.UnicastRemoteObject
`clone, exportObject, exportObject, exportObject, unexportObject`

Methods inherited from class java.rmi.server.RemoteServer
`getClientHost, getLog, setLog`

Methods inherited from class java.rmi.server.RemoteObject
`equals, getRef, hashCode, toString, toStub`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Methods inherited from interface visad.RemoteThing
`getTick, incTick`

Field Detail

### AdaptedData

    final transient DataImpl AdaptedData

  'this' is the Remote adaptor for AdaptedData (which is local); AdaptedData is transient because UnicastRemoteObject is Serializable, but a copy of 'this' on another JVM will not be local to AdaptedData and cannot adapt it; the methods of RemoteDataImpl test for null AdaptedData

Constructor Detail

### RemoteDataImpl

    public RemoteDataImpl(DataImpl data)
                   throws RemoteException

  construct a RemoteDataImpl adapting local data

Parameters:
  `data` - adapted DataImpl
Throws:
  `RemoteException` - an RMI error occurred

Method Detail

### local

    public DataImpl local()
                   throws VisADException,
                          RemoteException

  Specified by:
    `local` in interface `Data`
  Returns:
    a local copy (AdaptedData, which is Serializable)
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### getType

    public MathType getType()
                     throws VisADException,
                            RemoteException

  Specified by:
    `getType` in interface `Data`
  Returns:
    MathType of this Data
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### isMissing

    public boolean isMissing()
                      throws VisADException,
                             RemoteException

  Specified by:
    `isMissing` in interface `Data`
  Returns:
    flag indicating whether this Data has a missing value
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### binary

    public Data binary(Data data,
                       int op,
                       int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  Pointwise binary operation between this (AdaptedData) and data. Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains or Sets (regarded as domains of Fields wthout ranges). Data.ADD is only op defined for Text, interpreted as concatenate. MathTypes of this and data must match, or one may match the range of the other if it is a FunctionType.

  Specified by:
    `binary` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `op` - may be Data.ADD, Data.SUBTRACT, etc; these include all binary operations defined for Java primitive data types
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result, which takes the MathType of this unless the default Units of that MathType conflict with Units of the result, in which case a generic MathType with appropriate Units is constructed
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### binary

    public Data binary(Data data,
                       int op,
                       MathType new_type,
                       int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  Pointwise binary operation between this (AdaptedData) and data. Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains or Sets (regarded as domains of Fields wthout ranges). Data.ADD is only op defined for Text, interpreted as concatenate. MathTypes of this and data must match, or one may match the range of the other if it is a FunctionType.

  Specified by:
    `binary` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `op` - may be Data.ADD, Data.SUBTRACT, etc; these include all binary operations defined for Java primitive data types
    `new_type` - MathType of the result
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result, with MathType = new_type
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### add

    public Data add(Data data)
             throws VisADException,
                    RemoteException

  call binary() to add data to this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `add` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### subtract

    public Data subtract(Data data)
                  throws VisADException,
                         RemoteException

  call binary() to subtract data from this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `subtract` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### multiply

    public Data multiply(Data data)
                  throws VisADException,
                         RemoteException

  call binary() to multiply this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `multiply` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### divide

    public Data divide(Data data)
                throws VisADException,
                       RemoteException

  call binary() to divide this by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `divide` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### pow

    public Data pow(Data data)
             throws VisADException,
                    RemoteException

  call binary() to raise this to data power, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `pow` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### max

    public Data max(Data data)
             throws VisADException,
                    RemoteException

  call binary() to take the max of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `max` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### min

    public Data min(Data data)
             throws VisADException,
                    RemoteException

  call binary() to take the min of this and data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `min` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2

    public Data atan2(Data data)
               throws VisADException,
                      RemoteException

  call binary() to take the atan of this by data producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `atan2` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2Degrees

    public Data atan2Degrees(Data data)
                      throws VisADException,
                             RemoteException

  call binary() to take the atan of this by data producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `atan2Degrees` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### remainder

    public Data remainder(Data data)
                   throws VisADException,
                          RemoteException

  call binary() to take the remainder of this divided by data, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `remainder` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### add

    public Data add(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to add data to this

  Specified by:
    `add` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### subtract

    public Data subtract(Data data,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  call binary() to subtract data from this

  Specified by:
    `subtract` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### multiply

    public Data multiply(Data data,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  call binary() to multiply this by data

  Specified by:
    `multiply` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### divide

    public Data divide(Data data,
                       int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  call binary() to divide this by data

  Specified by:
    `divide` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### pow

    public Data pow(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to raise this to data power

  Specified by:
    `pow` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### max

    public Data max(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to take the max of this and data

  Specified by:
    `max` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### min

    public Data min(Data data,
                    int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call binary() to take the min of this and data

  Specified by:
    `min` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2

    public Data atan2(Data data,
                      int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  call binary() to take the atan of this by data producing radian Units

  Specified by:
    `atan2` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan2Degrees

    public Data atan2Degrees(Data data,
                             int sampling_mode,
                             int error_mode)
                      throws VisADException,
                             RemoteException

  call binary() to take the atan of this by data producing degree Units

  Specified by:
    `atan2Degrees` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### remainder

    public Data remainder(Data data,
                          int sampling_mode,
                          int error_mode)
                   throws VisADException,
                          RemoteException

  call binary() to take the remainder of this divided by data

  Specified by:
    `remainder` in interface `Data`
  Parameters:
    `data` - other Data operand for binary operation
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### unary

    public Data unary(int op,
                      int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  Pointwise unary operation applied to this (AdaptedData). Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains, Sets (regarded as domains of Fields wthout ranges) or Text.

  Specified by:
    `unary` in interface `Data`
  Parameters:
    `op` - may be Data.ABS, Data.ACOS, etc; these include all unary operations defined for Java primitive data types
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation, which takes the MathType of this unless the default Units of that MathType conflict with Units of the result, in which case a generic MathType with appropriate Units is constructed
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### unary

    public Data unary(int op,
                      MathType new_type,
                      int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  Pointwise unary operation applied to this (AdaptedData). Applies to Reals, Tuples (recursively to components), and to Field ranges (Field domains implicitly resampled if necessary). Does not apply to Field domains, Sets (regarded as domains of Fields wthout ranges) or Text.

  Specified by:
    `unary` in interface `Data`
  Parameters:
    `op` - may be Data.ABS, Data.ACOS, etc; these include all unary operations defined for Java primitive data types
    `new_type` - MathType of the result
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result, with MathType = new_type
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### changeMathType

    public Data changeMathType(MathType new_type)
                        throws VisADException,
                               RemoteException

  call unary() to clone this except with a new MathType

  Specified by:
    `changeMathType` in interface `Data`
  Parameters:
    `new_type` - MathType of returned Data object
  Returns:
    clone of this Data object except with new MathType
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### abs

    public Data abs()
             throws VisADException,
                    RemoteException

  call unary() to take the absolute value of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `abs` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acos

    public Data acos()
              throws VisADException,
                     RemoteException

  call unary() to take the arccos of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `acos` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acosDegrees

    public Data acosDegrees()
                     throws VisADException,
                            RemoteException

  call unary() to take the arccos of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `acosDegrees` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asin

    public Data asin()
              throws VisADException,
                     RemoteException

  call unary() to take the arcsin of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `asin` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asinDegrees

    public Data asinDegrees()
                     throws VisADException,
                            RemoteException

  call unary() to take the arcsin of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `asinDegrees` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan

    public Data atan()
              throws VisADException,
                     RemoteException

  call unary() to take the arctan of this producing radian Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `atan` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atanDegrees

    public Data atanDegrees()
                     throws VisADException,
                            RemoteException

  call unary() to take the arctan of this producing degree Units, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `atanDegrees` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### ceil

    public Data ceil()
              throws VisADException,
                     RemoteException

  call unary() to take the ceiling of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `ceil` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cos

    public Data cos()
             throws VisADException,
                    RemoteException

  call unary() to take the cos of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `cos` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cosDegrees

    public Data cosDegrees()
                    throws VisADException,
                           RemoteException

  call unary() to take the cos of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `cosDegrees` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### exp

    public Data exp()
             throws VisADException,
                    RemoteException

  call unary() to take the exponent of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `exp` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### floor

    public Data floor()
               throws VisADException,
                      RemoteException

  call unary() to take the floor of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `floor` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### log

    public Data log()
             throws VisADException,
                    RemoteException

  call unary() to take the log of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `log` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### rint

    public Data rint()
              throws VisADException,
                     RemoteException

  call unary() to take the rint (essentially round) of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `rint` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### round

    public Data round()
               throws VisADException,
                      RemoteException

  call unary() to take the round of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `round` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sin

    public Data sin()
             throws VisADException,
                    RemoteException

  call unary() to take the sin of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `sin` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sinDegrees

    public Data sinDegrees()
                    throws VisADException,
                           RemoteException

  call unary() to take the sin of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `sinDegrees` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sqrt

    public Data sqrt()
              throws VisADException,
                     RemoteException

  call unary() to take the square root of this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `sqrt` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tan

    public Data tan()
             throws VisADException,
                    RemoteException

  call unary() to take the tan of this assuming radian Units unless this actual Units are degrees, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `tan` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tanDegrees

    public Data tanDegrees()
                    throws VisADException,
                           RemoteException

  call unary() to take the tan of this assuming degree Units unless this actual Units are radians, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `tanDegrees` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### negate

    public Data negate()
                throws VisADException,
                       RemoteException

  call unary() to negate this, using default modes for sampling (Data.NEAREST_NEIGHBOR) and error estimation (Data.NO_ERRORS)

  Specified by:
    `negate` in interface `Data`
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### abs

    public Data abs(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the absolute value of this

  Specified by:
    `abs` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acos

    public Data acos(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the arccos of this producing radian Units

  Specified by:
    `acos` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### acosDegrees

    public Data acosDegrees(int sampling_mode,
                            int error_mode)
                     throws VisADException,
                            RemoteException

  call unary() to take the arccos of this producing degree Units

  Specified by:
    `acosDegrees` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asin

    public Data asin(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the arcsin of this producing radian Units

  Specified by:
    `asin` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### asinDegrees

    public Data asinDegrees(int sampling_mode,
                            int error_mode)
                     throws VisADException,
                            RemoteException

  call unary() to take the arcsin of this producing degree Units

  Specified by:
    `asinDegrees` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atan

    public Data atan(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the arctan of this producing radian Units

  Specified by:
    `atan` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### atanDegrees

    public Data atanDegrees(int sampling_mode,
                            int error_mode)
                     throws VisADException,
                            RemoteException

  call unary() to take the arctan of this producing degree Units

  Specified by:
    `atanDegrees` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### ceil

    public Data ceil(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the ceiling of this

  Specified by:
    `ceil` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cos

    public Data cos(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the cos of this assuming radian Units unless this actual Units are degrees

  Specified by:
    `cos` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### cosDegrees

    public Data cosDegrees(int sampling_mode,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  call unary() to take the cos of this assuming degree Units unless this actual Units are radians

  Specified by:
    `cosDegrees` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### exp

    public Data exp(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the exponent of this

  Specified by:
    `exp` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### floor

    public Data floor(int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  call unary() to take the floor of this

  Specified by:
    `floor` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### log

    public Data log(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the log of this

  Specified by:
    `log` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### rint

    public Data rint(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the rint (essentially round) of this

  Specified by:
    `rint` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### round

    public Data round(int sampling_mode,
                      int error_mode)
               throws VisADException,
                      RemoteException

  call unary() to take the round of this

  Specified by:
    `round` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sin

    public Data sin(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the sin of this assuming radian Units unless this actual Units are degrees

  Specified by:
    `sin` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sinDegrees

    public Data sinDegrees(int sampling_mode,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  call unary() to take the sin of this assuming degree Units unless this actual Units are radians

  Specified by:
    `sinDegrees` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### sqrt

    public Data sqrt(int sampling_mode,
                     int error_mode)
              throws VisADException,
                     RemoteException

  call unary() to take the square root of this

  Specified by:
    `sqrt` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tan

    public Data tan(int sampling_mode,
                    int error_mode)
             throws VisADException,
                    RemoteException

  call unary() to take the tan of this assuming radian Units unless this actual Units are degrees

  Specified by:
    `tan` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### tanDegrees

    public Data tanDegrees(int sampling_mode,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  call unary() to take the tan of this assuming degree Units unless this actual Units are radians

  Specified by:
    `tanDegrees` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### negate

    public Data negate(int sampling_mode,
                       int error_mode)
                throws VisADException,
                       RemoteException

  call unary() to negate this

  Specified by:
    `negate` in interface `Data`
  Parameters:
    `sampling_mode` - may be Data.NEAREST_NEIGHBOR or Data.WEIGHTED_AVERAGE
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    result of operation
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public double[][] computeRanges(RealType[] reals)
                             throws VisADException,
                                    RemoteException

  compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D

  Specified by:
    `computeRanges` in interface `Data`
  Returns:
    double[reals.length][2] giving the low and high value in this for each RealType in reals
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    int n)
                             throws VisADException,
                                    RemoteException

  Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector. Called from DataRenderer with n = DisplayImpl.getScalarCount().

  Specified by:
    `computeRanges` in interface `Data`
  Parameters:
    `type` - ShadowType generated for MathType of this
    `n` - number of RealTypes in DisplayImpl.RealTypeVector
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    DataShadow shadow)
                             throws VisADException,
                                    RemoteException

  Recursive version of computeRanges(), called down through Data object tree.

  Specified by:
    `computeRanges` in interface `Data`
  Parameters:
    `type` - ShadowType generated for MathType of this
    `shadow` - DataShadow instance whose contained double[][] array and animation sampling Set are modified according to RealType values in this, and used as return value
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### adjustSamplingError

    public Data adjustSamplingError(Data error,
                                    int error_mode)
                             throws VisADException,
                                    RemoteException

  return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode

  Specified by:
    `adjustSamplingError` in interface `Data`
  Parameters:
    `error` -
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    clone of this, except with ErrorEstimates set according to values in error
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### longString

    public String longString()
                      throws VisADException,
                             RemoteException

  Specified by:
    `longString` in interface `Data`
  Returns:
    a longer String than returned by toString()
  Throws:
    `VisADException`
    `RemoteException`

### longString

    public String longString(String pre)
                      throws VisADException,
                             RemoteException

  Specified by:
    `longString` in interface `Data`
  Parameters:
    `pre` - String added to start of each line
  Returns:
    a longer String than returned by toString(), indented by pre (a string of blanks)
  Throws:
    `VisADException`
    `RemoteException`

### dataClone

    public Object dataClone()
                     throws RemoteException

  A VisAD adaptation of clone that works for local or remote Data. Catches CloneNotSupportedException and throws message in a RuntimeException.

  Specified by:
    `dataClone` in interface `Data`
  Returns:
    for DataImpl return clone(), and for RemoteDataImpl return clone() inherited from UnicastRemoteObject
  Throws:
    `RemoteException`